---
title: Customize Surveys with CSS
product: Form Library
description: A free demo for JavaScript that shows how to easily customize your SurveyJS surveys or forms with custom CSS. Create a unique survey design that matches your brand's look and feel.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/customize-survey-with-css/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Customize Surveys with CSS (Vanilla JS)

SurveyJS Form Library enables you to customize the appearance of your survey using CSS. Applied CSS classes are stored in a [JSON object](https://github.com/surveyjs/survey-library/blob/master/packages/survey-core/src/defaultCss/defaultCss.ts#L13). To override a CSS class, assign a substitute class to a corresponding JSON object property. In this demo, the `customCss` object is used to override CSS classes for question content, answered questions, and titles of required questions. Assign this object to `SurveyModel`'s [`css`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#css) property.

You can also override styles dynamically based on a condition. Depending on the survey element whose classes you want to override, handle the following events:

- [`onUpdateQuestionCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdateQuestionCssClasses)
- [`onUpdatePanelCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePanelCssClasses)
- [`onUpdatePageCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePageCssClasses)
- [`onUpdateChoiceItemCss`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUpdateChoiceItemCss)

The event handlers accept an object with useful properties as the second `options` parameter. Redefine individual properties in the `options.cssClasses` object to override required CSS classes. For example, this demo shows how to handle the `onUpdateQuestionCssClasses` event to override styles for Checkboxes questions only.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
.question-answered {
  background-color: rgba(25, 179, 148, 0.05);
}

.question-content .question-root {
  border: 1px solid lightgray;
  border-radius: 5px;
  border-left: 4px solid #18a689;
  padding: 20px;
  margin: 10px 0;
}

.question-content .question-root-checkboxes {
  border-left: 4px solid orange;
}

.question-title-required {
  color: #e60a3e;
}
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const customCss = {
    "question": {
        "content": "question-content",
        "answered": "question-answered",
        "titleRequired": "question-title-required"
    }
};
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.css = customCss;

survey.onUpdateQuestionCssClasses.add(function(_, options) {
    const classes = options.cssClasses;
    classes.root = "question-root";
    if (options.question.getType() === "checkbox") {
        classes.root += " question-root-checkboxes";
    }
});


survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "radio-button-group",
      "title": "Radio Button Group",
      "choices": [ "Yes", "No" ]
    },
    {
      "type": "checkbox",
      "name": "checkboxes",
      "title": "Checkboxes",
      "choices": [ "Item 1", "Item 2", "Item 3" ]
    },
    {
      "type": "radiogroup",
      "name": "required-radio-button-group",
      "title": "Required Question",
      "isRequired": true,
      "choices": [ "Yes", "No" ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/customize-survey-with-css/angular.md)
- [React](https://surveyjs.io/form-library/examples/customize-survey-with-css/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/customize-survey-with-css/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/customize-survey-with-css/jquery.md)


---
title: Customize Surveys with CSS
product: Form Library
description: A free demo for JavaScript that shows how to easily customize your SurveyJS surveys or forms with custom CSS. Create a unique survey design that matches your brand's look and feel.
framework: React
source: https://surveyjs.io/form-library/examples/customize-survey-with-css/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Customize Surveys with CSS (React)

SurveyJS Form Library enables you to customize the appearance of your survey using CSS. Applied CSS classes are stored in a [JSON object](https://github.com/surveyjs/survey-library/blob/master/packages/survey-core/src/defaultCss/defaultCss.ts#L13). To override a CSS class, assign a substitute class to a corresponding JSON object property. In this demo, the `customCss` object is used to override CSS classes for question content, answered questions, and titles of required questions. Assign this object to `SurveyModel`'s [`css`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#css) property.

You can also override styles dynamically based on a condition. Depending on the survey element whose classes you want to override, handle the following events:

- [`onUpdateQuestionCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdateQuestionCssClasses)
- [`onUpdatePanelCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePanelCssClasses)
- [`onUpdatePageCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePageCssClasses)
- [`onUpdateChoiceItemCss`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUpdateChoiceItemCss)

The event handlers accept an object with useful properties as the second `options` parameter. Redefine individual properties in the `options.cssClasses` object to override required CSS classes. For example, this demo shows how to handle the `onUpdateQuestionCssClasses` event to override styles for Checkboxes questions only.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const customCss = {
    "question": {
        "content": "question-content",
        "answered": "question-answered",
        "titleRequired": "question-title-required"
    }
};
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.css = customCss;
    
    survey.onUpdateQuestionCssClasses.add(function(_, options) {
        const classes = options.cssClasses;
        classes.root = "question-root";
        if (options.question.getType() === "checkbox") {
            classes.root += " question-root-checkboxes";
        }
    });
    
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
.question-answered {
  background-color: rgba(25, 179, 148, 0.05);
}

.question-content .question-root {
  border: 1px solid lightgray;
  border-radius: 5px;
  border-left: 4px solid #18a689;
  padding: 20px;
  margin: 10px 0;
}

.question-content .question-root-checkboxes {
  border-left: 4px solid orange;
}

.question-title-required {
  color: #e60a3e;
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "radio-button-group",
      "title": "Radio Button Group",
      "choices": [ "Yes", "No" ]
    },
    {
      "type": "checkbox",
      "name": "checkboxes",
      "title": "Checkboxes",
      "choices": [ "Item 1", "Item 2", "Item 3" ]
    },
    {
      "type": "radiogroup",
      "name": "required-radio-button-group",
      "title": "Required Question",
      "isRequired": true,
      "choices": [ "Yes", "No" ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/customize-survey-with-css/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/customize-survey-with-css/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/customize-survey-with-css/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/customize-survey-with-css/vanillajs.md)


---
title: Customize Surveys with CSS
product: Form Library
description: A free demo for JavaScript that shows how to easily customize your SurveyJS surveys or forms with custom CSS. Create a unique survey design that matches your brand's look and feel.
framework: Angular
source: https://surveyjs.io/form-library/examples/customize-survey-with-css/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Customize Surveys with CSS (Angular)

SurveyJS Form Library enables you to customize the appearance of your survey using CSS. Applied CSS classes are stored in a [JSON object](https://github.com/surveyjs/survey-library/blob/master/packages/survey-core/src/defaultCss/defaultCss.ts#L13). To override a CSS class, assign a substitute class to a corresponding JSON object property. In this demo, the `customCss` object is used to override CSS classes for question content, answered questions, and titles of required questions. Assign this object to `SurveyModel`'s [`css`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#css) property.

You can also override styles dynamically based on a condition. Depending on the survey element whose classes you want to override, handle the following events:

- [`onUpdateQuestionCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdateQuestionCssClasses)
- [`onUpdatePanelCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePanelCssClasses)
- [`onUpdatePageCssClasses`](https://surveyjs.io/form-library/documentation/surveymodel#onUpdatePageCssClasses)
- [`onUpdateChoiceItemCss`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUpdateChoiceItemCss)

The event handlers accept an object with useful properties as the second `options` parameter. Redefine individual properties in the `options.cssClasses` object to override required CSS classes. For example, this demo shows how to handle the `onUpdateQuestionCssClasses` event to override styles for Checkboxes questions only.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "radio-button-group",
      "title": "Radio Button Group",
      "choices": [ "Yes", "No" ]
    },
    {
      "type": "checkbox",
      "name": "checkboxes",
      "title": "Checkboxes",
      "choices": [ "Item 1", "Item 2", "Item 3" ]
    },
    {
      "type": "radiogroup",
      "name": "required-radio-button-group",
      "title": "Required Question",
      "isRequired": true,
      "choices": [ "Yes", "No" ]
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
.question-answered {
  background-color: rgba(25, 179, 148, 0.05);
}

.question-content .question-root {
  border: 1px solid lightgray;
  border-radius: 5px;
  border-left: 4px solid #18a689;
  padding: 20px;
  margin: 10px 0;
}

.question-content .question-root-checkboxes {
  border-left: 4px solid orange;
}

.question-title-required {
  color: #e60a3e;
}
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

const customCss = {
    "question": {
        "content": "question-content",
        "answered": "question-answered",
        "titleRequired": "question-title-required"
    }
};
@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.css = customCss;
        
        survey.onUpdateQuestionCssClasses.add(function(_, options) {
            const classes = options.cssClasses;
            classes.root = "question-root";
            if (options.question.getType() === "checkbox") {
                classes.root += " question-root-checkboxes";
            }
        });
        
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.question-answered {
  background-color: rgba(25, 179, 148, 0.05);
}

.question-content .question-root {
  border: 1px solid lightgray;
  border-radius: 5px;
  border-left: 4px solid #18a689;
  padding: 20px;
  margin: 10px 0;
}

.question-content .question-root-checkboxes {
  border-left: 4px solid orange;
}

.question-title-required {
  color: #e60a3e;
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/customize-survey-with-css/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/customize-survey-with-css/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/customize-survey-with-css/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/customize-survey-with-css/vanillajs.md)
